#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_DESCRIPTOR_UPDATE_TEMPLATE_SPEC_VERSION")]
pub const KHR_DESCRIPTOR_UPDATE_TEMPLATE_SPEC_VERSION: u32 = 1;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_DESCRIPTOR_UPDATE_TEMPLATE_EXTENSION_NAME")]
pub const KHR_DESCRIPTOR_UPDATE_TEMPLATE_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_KHR_descriptor_update_template");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_CREATE_DESCRIPTOR_UPDATE_TEMPLATE_KHR: *const std::os::raw::c_char = crate::cstr!("vkCreateDescriptorUpdateTemplateKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_DESTROY_DESCRIPTOR_UPDATE_TEMPLATE_KHR: *const std::os::raw::c_char = crate::cstr!("vkDestroyDescriptorUpdateTemplateKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_UPDATE_DESCRIPTOR_SET_WITH_TEMPLATE_KHR: *const std::os::raw::c_char = crate::cstr!("vkUpdateDescriptorSetWithTemplateKHR");
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkDescriptorUpdateTemplateCreateFlagsKHR.html)) · Alias <br/> VkDescriptorUpdateTemplateCreateFlags - Reserved for future use\n[](#_c_specification)C Specification\n----------\n\n```\n// Provided by VK_VERSION_1_1\ntypedef VkFlags VkDescriptorUpdateTemplateCreateFlags;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_descriptor_update_template\ntypedef VkDescriptorUpdateTemplateCreateFlags VkDescriptorUpdateTemplateCreateFlagsKHR;\n```\n[](#_description)Description\n----------\n\n[`crate::vk::DescriptorUpdateTemplateCreateFlagBits`] is a bitmask type for setting a\nmask, but is currently reserved for future use.\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DescriptorUpdateTemplateCreateInfo`]\n"]
#[doc(alias = "VkDescriptorUpdateTemplateCreateFlagsKHR")]
#[allow(non_camel_case_types)]
pub type DescriptorUpdateTemplateCreateFlagsKHR = crate::vk1_1::DescriptorUpdateTemplateCreateFlags;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkDescriptorUpdateTemplateKHR.html)) · Alias <br/> VkDescriptorUpdateTemplate - Opaque handle to a descriptor update template\n[](#_c_specification)C Specification\n----------\n\nA descriptor update template specifies a mapping from descriptor update\ninformation in host memory to descriptors in a descriptor set.\nIt is designed to avoid passing redundant information to the driver when\nfrequently updating the same set of descriptors in descriptor sets.\n\nDescriptor update template objects are represented by[`crate::vk::DescriptorUpdateTemplate`] handles:\n\n```\n// Provided by VK_VERSION_1_1\nVK_DEFINE_NON_DISPATCHABLE_HANDLE(VkDescriptorUpdateTemplate)\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_descriptor_update_template\ntypedef VkDescriptorUpdateTemplate VkDescriptorUpdateTemplateKHR;\n```\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DeviceLoader::cmd_push_descriptor_set_with_template_khr`], [`crate::vk::PFN_vkCreateDescriptorUpdateTemplate`], [`crate::vk::PFN_vkCreateDescriptorUpdateTemplate`], [`crate::vk::PFN_vkDestroyDescriptorUpdateTemplate`], [`crate::vk::PFN_vkDestroyDescriptorUpdateTemplate`], [`crate::vk::PFN_vkUpdateDescriptorSetWithTemplate`], [`crate::vk::PFN_vkUpdateDescriptorSetWithTemplate`]\n[](#_document_notes)Document Notes\n----------\n\nFor more information, see the [Vulkan Specification](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#VkDescriptorUpdateTemplate)\n\nThis page is extracted from the Vulkan Specification.\nFixes and changes should be made to the Specification, not directly.\n[](#_copyright)Copyright\n----------\n\nCopyright 2014-2021 The Khronos Group Inc.\n\nSPDX-License-Identifier: CC-BY-4.0\n"]
#[doc(alias = "VkDescriptorUpdateTemplateKHR")]
#[allow(non_camel_case_types)]
pub type DescriptorUpdateTemplateKHR = crate::vk1_1::DescriptorUpdateTemplate;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkDescriptorUpdateTemplateTypeKHR.html)) · Alias <br/> VkDescriptorUpdateTemplateType - Indicates the valid usage of the descriptor update template\n[](#_c_specification)C Specification\n----------\n\nThe descriptor update template type is determined by the[`crate::vk::DescriptorUpdateTemplateCreateInfo::template_type`] property,\nwhich takes the following values:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef enum VkDescriptorUpdateTemplateType {\n    VK_DESCRIPTOR_UPDATE_TEMPLATE_TYPE_DESCRIPTOR_SET = 0,\n  // Provided by VK_KHR_push_descriptor with VK_VERSION_1_1, VK_KHR_push_descriptor with VK_KHR_descriptor_update_template, VK_KHR_descriptor_update_template with VK_KHR_push_descriptor\n    VK_DESCRIPTOR_UPDATE_TEMPLATE_TYPE_PUSH_DESCRIPTORS_KHR = 1,\n  // Provided by VK_KHR_descriptor_update_template\n    VK_DESCRIPTOR_UPDATE_TEMPLATE_TYPE_DESCRIPTOR_SET_KHR = VK_DESCRIPTOR_UPDATE_TEMPLATE_TYPE_DESCRIPTOR_SET,\n} VkDescriptorUpdateTemplateType;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_descriptor_update_template\ntypedef VkDescriptorUpdateTemplateType VkDescriptorUpdateTemplateTypeKHR;\n```\n[](#_description)Description\n----------\n\n* [`crate::vk::DescriptorUpdateTemplateType::DESCRIPTOR_SET`] specifies that\n  the descriptor update template will be used for descriptor set updates\n  only.\n\n* [`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`] specifies\n  that the descriptor update template will be used for push descriptor\n  updates only.\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DescriptorUpdateTemplateCreateInfo`]\n"]
#[doc(alias = "VkDescriptorUpdateTemplateTypeKHR")]
#[allow(non_camel_case_types)]
pub type DescriptorUpdateTemplateTypeKHR = crate::vk1_1::DescriptorUpdateTemplateType;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkDescriptorUpdateTemplateEntryKHR.html)) · Alias <br/> VkDescriptorUpdateTemplateEntry - Describes a single descriptor update of the descriptor update template\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::DescriptorUpdateTemplateEntry`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkDescriptorUpdateTemplateEntry {\n    uint32_t            dstBinding;\n    uint32_t            dstArrayElement;\n    uint32_t            descriptorCount;\n    VkDescriptorType    descriptorType;\n    size_t              offset;\n    size_t              stride;\n} VkDescriptorUpdateTemplateEntry;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_descriptor_update_template\ntypedef VkDescriptorUpdateTemplateEntry VkDescriptorUpdateTemplateEntryKHR;\n```\n[](#_members)Members\n----------\n\n* `dstBinding` is the descriptor binding to update when using this\n  descriptor update template.\n\n* `dstArrayElement` is the starting element in the array belonging to`dstBinding`.\n  If the descriptor binding identified by `dstBinding` has a\n  descriptor type of [`crate::vk::DescriptorType::INLINE_UNIFORM_BLOCK_EXT`]then `dstArrayElement` specifies the starting byte offset to update.\n\n* `descriptorCount` is the number of descriptors to update.\n  If `descriptorCount` is greater than the number of remaining array\n  elements in the destination binding, those affect consecutive bindings\n  in a manner similar to [`crate::vk::WriteDescriptorSet`] above.\n  If the descriptor binding identified by `dstBinding` has a\n  descriptor type of [`crate::vk::DescriptorType::INLINE_UNIFORM_BLOCK_EXT`]then `descriptorCount` specifies the number of bytes to update and\n  the remaining array elements in the destination binding refer to the\n  remaining number of bytes in it.\n\n* `descriptorType` is a [`crate::vk::DescriptorType`] specifying the type of\n  the descriptor.\n\n* `offset` is the offset in bytes of the first binding in the raw data\n  structure.\n\n* `stride` is the stride in bytes between two consecutive array\n  elements of the descriptor update informations in the raw data\n  structure.\n  The actual pointer ptr for each array element j of update entry i is\n  computed using the following formula:\n\n  ```\n      const char *ptr = (const char *)pData + pDescriptorUpdateEntries[i].offset + j * pDescriptorUpdateEntries[i].stride\n  ```\n\n  The stride is useful in case the bindings are stored in structs along with\n  other data.\n  If `descriptorType` is [`crate::vk::DescriptorType::INLINE_UNIFORM_BLOCK_EXT`]then the value of `stride` is ignored and the stride is assumed to be`1`, i.e. the descriptor update information for them is always specified as\n  a contiguous range.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkDescriptorUpdateTemplateEntry-dstBinding-00354  \n  `dstBinding` **must** be a valid binding in the descriptor set layout\n  implicitly specified when using a descriptor update template to update\n  descriptors\n\n* []() VUID-VkDescriptorUpdateTemplateEntry-dstArrayElement-00355  \n  `dstArrayElement` and `descriptorCount` **must** be less than or\n  equal to the number of array elements in the descriptor set binding\n  implicitly specified when using a descriptor update template to update\n  descriptors, and all applicable consecutive bindings, as described by[https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#descriptorsets-updates-consecutive](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#descriptorsets-updates-consecutive)\n\n* []() VUID-VkDescriptorUpdateTemplateEntry-descriptor-02226  \n   If `descriptor` type is[`crate::vk::DescriptorType::INLINE_UNIFORM_BLOCK_EXT`], `dstArrayElement`**must** be an integer multiple of `4`\n\n* []() VUID-VkDescriptorUpdateTemplateEntry-descriptor-02227  \n   If `descriptor` type is[`crate::vk::DescriptorType::INLINE_UNIFORM_BLOCK_EXT`], `descriptorCount`**must** be an integer multiple of `4`\n\nValid Usage (Implicit)\n\n* []() VUID-VkDescriptorUpdateTemplateEntry-descriptorType-parameter  \n  `descriptorType` **must** be a valid [`crate::vk::DescriptorType`] value\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DescriptorType`], [`crate::vk::DescriptorUpdateTemplateCreateInfo`]\n"]
#[doc(alias = "VkDescriptorUpdateTemplateEntryKHR")]
#[allow(non_camel_case_types)]
pub type DescriptorUpdateTemplateEntryKHR = crate::vk1_1::DescriptorUpdateTemplateEntry;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkDescriptorUpdateTemplateEntryKHR.html)) · Alias <br/> VkDescriptorUpdateTemplateEntry - Describes a single descriptor update of the descriptor update template\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::DescriptorUpdateTemplateEntry`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkDescriptorUpdateTemplateEntry {\n    uint32_t            dstBinding;\n    uint32_t            dstArrayElement;\n    uint32_t            descriptorCount;\n    VkDescriptorType    descriptorType;\n    size_t              offset;\n    size_t              stride;\n} VkDescriptorUpdateTemplateEntry;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_descriptor_update_template\ntypedef VkDescriptorUpdateTemplateEntry VkDescriptorUpdateTemplateEntryKHR;\n```\n[](#_members)Members\n----------\n\n* `dstBinding` is the descriptor binding to update when using this\n  descriptor update template.\n\n* `dstArrayElement` is the starting element in the array belonging to`dstBinding`.\n  If the descriptor binding identified by `dstBinding` has a\n  descriptor type of [`crate::vk::DescriptorType::INLINE_UNIFORM_BLOCK_EXT`]then `dstArrayElement` specifies the starting byte offset to update.\n\n* `descriptorCount` is the number of descriptors to update.\n  If `descriptorCount` is greater than the number of remaining array\n  elements in the destination binding, those affect consecutive bindings\n  in a manner similar to [`crate::vk::WriteDescriptorSet`] above.\n  If the descriptor binding identified by `dstBinding` has a\n  descriptor type of [`crate::vk::DescriptorType::INLINE_UNIFORM_BLOCK_EXT`]then `descriptorCount` specifies the number of bytes to update and\n  the remaining array elements in the destination binding refer to the\n  remaining number of bytes in it.\n\n* `descriptorType` is a [`crate::vk::DescriptorType`] specifying the type of\n  the descriptor.\n\n* `offset` is the offset in bytes of the first binding in the raw data\n  structure.\n\n* `stride` is the stride in bytes between two consecutive array\n  elements of the descriptor update informations in the raw data\n  structure.\n  The actual pointer ptr for each array element j of update entry i is\n  computed using the following formula:\n\n  ```\n      const char *ptr = (const char *)pData + pDescriptorUpdateEntries[i].offset + j * pDescriptorUpdateEntries[i].stride\n  ```\n\n  The stride is useful in case the bindings are stored in structs along with\n  other data.\n  If `descriptorType` is [`crate::vk::DescriptorType::INLINE_UNIFORM_BLOCK_EXT`]then the value of `stride` is ignored and the stride is assumed to be`1`, i.e. the descriptor update information for them is always specified as\n  a contiguous range.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkDescriptorUpdateTemplateEntry-dstBinding-00354  \n  `dstBinding` **must** be a valid binding in the descriptor set layout\n  implicitly specified when using a descriptor update template to update\n  descriptors\n\n* []() VUID-VkDescriptorUpdateTemplateEntry-dstArrayElement-00355  \n  `dstArrayElement` and `descriptorCount` **must** be less than or\n  equal to the number of array elements in the descriptor set binding\n  implicitly specified when using a descriptor update template to update\n  descriptors, and all applicable consecutive bindings, as described by[https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#descriptorsets-updates-consecutive](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#descriptorsets-updates-consecutive)\n\n* []() VUID-VkDescriptorUpdateTemplateEntry-descriptor-02226  \n   If `descriptor` type is[`crate::vk::DescriptorType::INLINE_UNIFORM_BLOCK_EXT`], `dstArrayElement`**must** be an integer multiple of `4`\n\n* []() VUID-VkDescriptorUpdateTemplateEntry-descriptor-02227  \n   If `descriptor` type is[`crate::vk::DescriptorType::INLINE_UNIFORM_BLOCK_EXT`], `descriptorCount`**must** be an integer multiple of `4`\n\nValid Usage (Implicit)\n\n* []() VUID-VkDescriptorUpdateTemplateEntry-descriptorType-parameter  \n  `descriptorType` **must** be a valid [`crate::vk::DescriptorType`] value\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DescriptorType`], [`crate::vk::DescriptorUpdateTemplateCreateInfo`]\n"]
#[doc(alias = "VkDescriptorUpdateTemplateEntryKHR")]
#[allow(non_camel_case_types)]
pub type DescriptorUpdateTemplateEntryKHRBuilder<'a> = crate::vk1_1::DescriptorUpdateTemplateEntryBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkDescriptorUpdateTemplateCreateInfoKHR.html)) · Alias <br/> VkDescriptorUpdateTemplateCreateInfo - Structure specifying parameters of a newly created descriptor update template\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::DescriptorUpdateTemplateCreateInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkDescriptorUpdateTemplateCreateInfo {\n    VkStructureType                           sType;\n    const void*                               pNext;\n    VkDescriptorUpdateTemplateCreateFlags     flags;\n    uint32_t                                  descriptorUpdateEntryCount;\n    const VkDescriptorUpdateTemplateEntry*    pDescriptorUpdateEntries;\n    VkDescriptorUpdateTemplateType            templateType;\n    VkDescriptorSetLayout                     descriptorSetLayout;\n    VkPipelineBindPoint                       pipelineBindPoint;\n    VkPipelineLayout                          pipelineLayout;\n    uint32_t                                  set;\n} VkDescriptorUpdateTemplateCreateInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_descriptor_update_template\ntypedef VkDescriptorUpdateTemplateCreateInfo VkDescriptorUpdateTemplateCreateInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `flags` is reserved for future use.\n\n* `descriptorUpdateEntryCount` is the number of elements in the`pDescriptorUpdateEntries` array.\n\n* `pDescriptorUpdateEntries` is a pointer to an array of[`crate::vk::DescriptorUpdateTemplateEntry`] structures describing the\n  descriptors to be updated by the descriptor update template.\n\n* `templateType` Specifies the type of the descriptor update template.\n  If set to [`crate::vk::DescriptorUpdateTemplateType::DESCRIPTOR_SET`] it**can** only be used to update descriptor sets with a fixed`descriptorSetLayout`.\n  If set to [`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`]it **can** only be used to push descriptor sets using the provided`pipelineBindPoint`, `pipelineLayout`, and `set` number.\n\n* `descriptorSetLayout` is the descriptor set layout used to build the\n  descriptor update template.\n  All descriptor sets which are going to be updated through the newly\n  created descriptor update template **must** be created with a layout that\n  matches (is the same as, or defined identically to) this layout.\n  This parameter is ignored if `templateType` is not[`crate::vk::DescriptorUpdateTemplateType::DESCRIPTOR_SET`].\n\n* `pipelineBindPoint` is a [`crate::vk::PipelineBindPoint`] indicating the\n  type of the pipeline that will use the descriptors.\n  This parameter is ignored if `templateType` is not[`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`]\n\n* `pipelineLayout` is a [`crate::vk::PipelineLayout`] object used to program\n  the bindings.\n  This parameter is ignored if `templateType` is not[`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`]\n\n* `set` is the set number of the descriptor set in the pipeline layout\n  that will be updated.\n  This parameter is ignored if `templateType` is not[`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`]\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-00350  \n   If `templateType` is[`crate::vk::DescriptorUpdateTemplateType::DESCRIPTOR_SET`],`descriptorSetLayout` **must** be a valid [`crate::vk::DescriptorSetLayout`]handle\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-00351  \n   If `templateType` is[`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`],`pipelineBindPoint` **must** be a valid [`crate::vk::PipelineBindPoint`] value\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-00352  \n   If `templateType` is[`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`],`pipelineLayout` **must** be a valid [`crate::vk::PipelineLayout`] handle\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-00353  \n   If `templateType` is[`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`], `set`**must** be the unique set number in the pipeline layout that uses a\n  descriptor set layout that was created with[`crate::vk::DescriptorSetLayoutCreateFlagBits::PUSH_DESCRIPTOR_KHR`]\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-04615  \n   If `templateType` is[`crate::vk::DescriptorUpdateTemplateType::DESCRIPTOR_SET`],`descriptorSetLayout` **must** not contain a binding with type[`crate::vk::DescriptorType::MUTABLE_VALVE`]\n\nValid Usage (Implicit)\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::DESCRIPTOR_UPDATE_TEMPLATE_CREATE_INFO`]\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-flags-zerobitmask  \n  `flags` **must** be `0`\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-pDescriptorUpdateEntries-parameter  \n  `pDescriptorUpdateEntries` **must** be a valid pointer to an array of `descriptorUpdateEntryCount` valid [`crate::vk::DescriptorUpdateTemplateEntry`] structures\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-parameter  \n  `templateType` **must** be a valid [`crate::vk::DescriptorUpdateTemplateType`] value\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-descriptorUpdateEntryCount-arraylength  \n  `descriptorUpdateEntryCount` **must** be greater than `0`\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-commonparent  \n   Both of `descriptorSetLayout`, and `pipelineLayout` that are valid handles of non-ignored parameters **must** have been created, allocated, or retrieved from the same [`crate::vk::Device`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DescriptorSetLayout`], [`crate::vk::DescriptorUpdateTemplateCreateFlagBits`], [`crate::vk::DescriptorUpdateTemplateEntry`], [`crate::vk::DescriptorUpdateTemplateType`], [`crate::vk::PipelineBindPoint`], [`crate::vk::PipelineLayout`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkCreateDescriptorUpdateTemplate`], [`crate::vk::PFN_vkCreateDescriptorUpdateTemplate`]\n"]
#[doc(alias = "VkDescriptorUpdateTemplateCreateInfoKHR")]
#[allow(non_camel_case_types)]
pub type DescriptorUpdateTemplateCreateInfoKHR = crate::vk1_1::DescriptorUpdateTemplateCreateInfo;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkDescriptorUpdateTemplateCreateInfoKHR.html)) · Alias <br/> VkDescriptorUpdateTemplateCreateInfo - Structure specifying parameters of a newly created descriptor update template\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::DescriptorUpdateTemplateCreateInfo`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_1\ntypedef struct VkDescriptorUpdateTemplateCreateInfo {\n    VkStructureType                           sType;\n    const void*                               pNext;\n    VkDescriptorUpdateTemplateCreateFlags     flags;\n    uint32_t                                  descriptorUpdateEntryCount;\n    const VkDescriptorUpdateTemplateEntry*    pDescriptorUpdateEntries;\n    VkDescriptorUpdateTemplateType            templateType;\n    VkDescriptorSetLayout                     descriptorSetLayout;\n    VkPipelineBindPoint                       pipelineBindPoint;\n    VkPipelineLayout                          pipelineLayout;\n    uint32_t                                  set;\n} VkDescriptorUpdateTemplateCreateInfo;\n```\n\nor the equivalent\n\n```\n// Provided by VK_KHR_descriptor_update_template\ntypedef VkDescriptorUpdateTemplateCreateInfo VkDescriptorUpdateTemplateCreateInfoKHR;\n```\n[](#_members)Members\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* `flags` is reserved for future use.\n\n* `descriptorUpdateEntryCount` is the number of elements in the`pDescriptorUpdateEntries` array.\n\n* `pDescriptorUpdateEntries` is a pointer to an array of[`crate::vk::DescriptorUpdateTemplateEntry`] structures describing the\n  descriptors to be updated by the descriptor update template.\n\n* `templateType` Specifies the type of the descriptor update template.\n  If set to [`crate::vk::DescriptorUpdateTemplateType::DESCRIPTOR_SET`] it**can** only be used to update descriptor sets with a fixed`descriptorSetLayout`.\n  If set to [`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`]it **can** only be used to push descriptor sets using the provided`pipelineBindPoint`, `pipelineLayout`, and `set` number.\n\n* `descriptorSetLayout` is the descriptor set layout used to build the\n  descriptor update template.\n  All descriptor sets which are going to be updated through the newly\n  created descriptor update template **must** be created with a layout that\n  matches (is the same as, or defined identically to) this layout.\n  This parameter is ignored if `templateType` is not[`crate::vk::DescriptorUpdateTemplateType::DESCRIPTOR_SET`].\n\n* `pipelineBindPoint` is a [`crate::vk::PipelineBindPoint`] indicating the\n  type of the pipeline that will use the descriptors.\n  This parameter is ignored if `templateType` is not[`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`]\n\n* `pipelineLayout` is a [`crate::vk::PipelineLayout`] object used to program\n  the bindings.\n  This parameter is ignored if `templateType` is not[`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`]\n\n* `set` is the set number of the descriptor set in the pipeline layout\n  that will be updated.\n  This parameter is ignored if `templateType` is not[`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`]\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-00350  \n   If `templateType` is[`crate::vk::DescriptorUpdateTemplateType::DESCRIPTOR_SET`],`descriptorSetLayout` **must** be a valid [`crate::vk::DescriptorSetLayout`]handle\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-00351  \n   If `templateType` is[`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`],`pipelineBindPoint` **must** be a valid [`crate::vk::PipelineBindPoint`] value\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-00352  \n   If `templateType` is[`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`],`pipelineLayout` **must** be a valid [`crate::vk::PipelineLayout`] handle\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-00353  \n   If `templateType` is[`crate::vk::DescriptorUpdateTemplateType::PUSH_DESCRIPTORS_KHR`], `set`**must** be the unique set number in the pipeline layout that uses a\n  descriptor set layout that was created with[`crate::vk::DescriptorSetLayoutCreateFlagBits::PUSH_DESCRIPTOR_KHR`]\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-04615  \n   If `templateType` is[`crate::vk::DescriptorUpdateTemplateType::DESCRIPTOR_SET`],`descriptorSetLayout` **must** not contain a binding with type[`crate::vk::DescriptorType::MUTABLE_VALVE`]\n\nValid Usage (Implicit)\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::DESCRIPTOR_UPDATE_TEMPLATE_CREATE_INFO`]\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-pNext-pNext  \n  `pNext` **must** be `NULL`\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-flags-zerobitmask  \n  `flags` **must** be `0`\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-pDescriptorUpdateEntries-parameter  \n  `pDescriptorUpdateEntries` **must** be a valid pointer to an array of `descriptorUpdateEntryCount` valid [`crate::vk::DescriptorUpdateTemplateEntry`] structures\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-templateType-parameter  \n  `templateType` **must** be a valid [`crate::vk::DescriptorUpdateTemplateType`] value\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-descriptorUpdateEntryCount-arraylength  \n  `descriptorUpdateEntryCount` **must** be greater than `0`\n\n* []() VUID-VkDescriptorUpdateTemplateCreateInfo-commonparent  \n   Both of `descriptorSetLayout`, and `pipelineLayout` that are valid handles of non-ignored parameters **must** have been created, allocated, or retrieved from the same [`crate::vk::Device`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DescriptorSetLayout`], [`crate::vk::DescriptorUpdateTemplateCreateFlagBits`], [`crate::vk::DescriptorUpdateTemplateEntry`], [`crate::vk::DescriptorUpdateTemplateType`], [`crate::vk::PipelineBindPoint`], [`crate::vk::PipelineLayout`], [`crate::vk::StructureType`], [`crate::vk::PFN_vkCreateDescriptorUpdateTemplate`], [`crate::vk::PFN_vkCreateDescriptorUpdateTemplate`]\n"]
#[doc(alias = "VkDescriptorUpdateTemplateCreateInfoKHR")]
#[allow(non_camel_case_types)]
pub type DescriptorUpdateTemplateCreateInfoKHRBuilder<'a> = crate::vk1_1::DescriptorUpdateTemplateCreateInfoBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCreateDescriptorUpdateTemplateKHR.html)) · Alias <br/> vkCreateDescriptorUpdateTemplate - Create a new descriptor update template\n[](#_c_specification)C Specification\n----------\n\nUpdating a large [`crate::vk::DescriptorSet`] array **can** be an expensive operation\nsince an application **must** specify one [`crate::vk::WriteDescriptorSet`] structure\nfor each descriptor or descriptor array to update, each of which\nre-specifies the same state when updating the same descriptor in multiple\ndescriptor sets.\nFor cases when an application wishes to update the same set of descriptors\nin multiple descriptor sets allocated using the same[`crate::vk::DescriptorSetLayout`], [`crate::vk::PFN_vkUpdateDescriptorSetWithTemplate`] **can** be\nused as a replacement for [`crate::vk::PFN_vkUpdateDescriptorSets`].\n\n[`crate::vk::DescriptorUpdateTemplate`] allows implementations to convert a set of\ndescriptor update operations on a single descriptor set to an internal\nformat that, in conjunction with [`crate::vk::PFN_vkUpdateDescriptorSetWithTemplate`]or [`crate::vk::DeviceLoader::cmd_push_descriptor_set_with_template_khr`], **can** be more efficient compared to calling [`crate::vk::PFN_vkUpdateDescriptorSets`]or [`crate::vk::DeviceLoader::cmd_push_descriptor_set_khr`].\nThe descriptors themselves are not specified in the[`crate::vk::DescriptorUpdateTemplate`], rather, offsets into an application\nprovided pointer to host memory are specified, which are combined with a\npointer passed to [`crate::vk::PFN_vkUpdateDescriptorSetWithTemplate`]or [`crate::vk::DeviceLoader::cmd_push_descriptor_set_with_template_khr`].\nThis allows large batches of updates to be executed without having to\nconvert application data structures into a strictly-defined Vulkan data\nstructure.\n\nTo create a descriptor update template, call:\n\n```\n// Provided by VK_VERSION_1_1\nVkResult vkCreateDescriptorUpdateTemplate(\n    VkDevice                                    device,\n    const VkDescriptorUpdateTemplateCreateInfo* pCreateInfo,\n    const VkAllocationCallbacks*                pAllocator,\n    VkDescriptorUpdateTemplate*                 pDescriptorUpdateTemplate);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_descriptor_update_template\nVkResult vkCreateDescriptorUpdateTemplateKHR(\n    VkDevice                                    device,\n    const VkDescriptorUpdateTemplateCreateInfo* pCreateInfo,\n    const VkAllocationCallbacks*                pAllocator,\n    VkDescriptorUpdateTemplate*                 pDescriptorUpdateTemplate);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that creates the descriptor update\n  template.\n\n* `pCreateInfo` is a pointer to a[`crate::vk::DescriptorUpdateTemplateCreateInfo`] structure specifying the set\n  of descriptors to update with a single call to[`crate::vk::DeviceLoader::cmd_push_descriptor_set_with_template_khr`] or[`crate::vk::PFN_vkUpdateDescriptorSetWithTemplate`].\n\n* `pAllocator` controls host memory allocation as described in the[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation) chapter.\n\n* `pDescriptorUpdateTemplate` is a pointer to a[`crate::vk::DescriptorUpdateTemplate`] handle in which the resulting\n  descriptor update template object is returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkCreateDescriptorUpdateTemplate-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkCreateDescriptorUpdateTemplate-pCreateInfo-parameter  \n  `pCreateInfo` **must** be a valid pointer to a valid [`crate::vk::DescriptorUpdateTemplateCreateInfo`] structure\n\n* []() VUID-vkCreateDescriptorUpdateTemplate-pAllocator-parameter  \n   If `pAllocator` is not `NULL`, `pAllocator` **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkCreateDescriptorUpdateTemplate-pDescriptorUpdateTemplate-parameter  \n  `pDescriptorUpdateTemplate` **must** be a valid pointer to a [`crate::vk::DescriptorUpdateTemplate`] handle\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::DescriptorUpdateTemplate`], [`crate::vk::DescriptorUpdateTemplateCreateInfo`], [`crate::vk::Device`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkCreateDescriptorUpdateTemplateKHR = crate::vk1_1::PFN_vkCreateDescriptorUpdateTemplate;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkDestroyDescriptorUpdateTemplateKHR.html)) · Alias <br/> vkDestroyDescriptorUpdateTemplate - Destroy a descriptor update template object\n[](#_c_specification)C Specification\n----------\n\nTo destroy a descriptor update template, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkDestroyDescriptorUpdateTemplate(\n    VkDevice                                    device,\n    VkDescriptorUpdateTemplate                  descriptorUpdateTemplate,\n    const VkAllocationCallbacks*                pAllocator);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_descriptor_update_template\nvoid vkDestroyDescriptorUpdateTemplateKHR(\n    VkDevice                                    device,\n    VkDescriptorUpdateTemplate                  descriptorUpdateTemplate,\n    const VkAllocationCallbacks*                pAllocator);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that has been used to create the\n  descriptor update template\n\n* `descriptorUpdateTemplate` is the descriptor update template to\n  destroy.\n\n* `pAllocator` controls host memory allocation as described in the[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation) chapter.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-vkDestroyDescriptorUpdateTemplate-descriptorSetLayout-00356  \n   If [`crate::vk::AllocationCallbacks`] were provided when`descriptorUpdateTemplate` was created, a compatible set of\n  callbacks **must** be provided here\n\n* []() VUID-vkDestroyDescriptorUpdateTemplate-descriptorSetLayout-00357  \n   If no [`crate::vk::AllocationCallbacks`] were provided when`descriptorUpdateTemplate` was created, `pAllocator` **must** be`NULL`\n\nValid Usage (Implicit)\n\n* []() VUID-vkDestroyDescriptorUpdateTemplate-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkDestroyDescriptorUpdateTemplate-descriptorUpdateTemplate-parameter  \n   If `descriptorUpdateTemplate` is not [VK\\_NULL\\_HANDLE](VK_NULL_HANDLE.html), `descriptorUpdateTemplate` **must** be a valid [`crate::vk::DescriptorUpdateTemplate`] handle\n\n* []() VUID-vkDestroyDescriptorUpdateTemplate-pAllocator-parameter  \n   If `pAllocator` is not `NULL`, `pAllocator` **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkDestroyDescriptorUpdateTemplate-descriptorUpdateTemplate-parent  \n   If `descriptorUpdateTemplate` is a valid handle, it **must** have been created, allocated, or retrieved from `device`\n\nHost Synchronization\n\n* Host access to `descriptorUpdateTemplate` **must** be externally synchronized\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::DescriptorUpdateTemplate`], [`crate::vk::Device`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkDestroyDescriptorUpdateTemplateKHR = crate::vk1_1::PFN_vkDestroyDescriptorUpdateTemplate;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkUpdateDescriptorSetWithTemplateKHR.html)) · Alias <br/> vkUpdateDescriptorSetWithTemplate - Update the contents of a descriptor set object using an update template\n[](#_c_specification)C Specification\n----------\n\nOnce a [`crate::vk::DescriptorUpdateTemplate`] has been created, descriptor sets**can** be updated by calling:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkUpdateDescriptorSetWithTemplate(\n    VkDevice                                    device,\n    VkDescriptorSet                             descriptorSet,\n    VkDescriptorUpdateTemplate                  descriptorUpdateTemplate,\n    const void*                                 pData);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_descriptor_update_template\nvoid vkUpdateDescriptorSetWithTemplateKHR(\n    VkDevice                                    device,\n    VkDescriptorSet                             descriptorSet,\n    VkDescriptorUpdateTemplate                  descriptorUpdateTemplate,\n    const void*                                 pData);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that updates the descriptor set.\n\n* `descriptorSet` is the descriptor set to update\n\n* `descriptorUpdateTemplate` is a [`crate::vk::DescriptorUpdateTemplate`]object specifying the update mapping between `pData` and the\n  descriptor set to update.\n\n* `pData` is a pointer to memory containing one or more [`crate::vk::DescriptorImageInfo`], [`crate::vk::DescriptorBufferInfo`], or [`crate::vk::BufferView`] structures\n  or [`crate::vk::AccelerationStructureKHR`]or [`crate::vk::AccelerationStructureNV`]handles used to write the descriptors.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-vkUpdateDescriptorSetWithTemplate-pData-01685  \n  `pData` **must** be a valid pointer to a memory containing one or more\n  valid instances of [`crate::vk::DescriptorImageInfo`],[`crate::vk::DescriptorBufferInfo`], or [`crate::vk::BufferView`] in a layout defined\n  by `descriptorUpdateTemplate` when it was created with[`crate::vk::PFN_vkCreateDescriptorUpdateTemplate`]\n\nValid Usage (Implicit)\n\n* []() VUID-vkUpdateDescriptorSetWithTemplate-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkUpdateDescriptorSetWithTemplate-descriptorSet-parameter  \n  `descriptorSet` **must** be a valid [`crate::vk::DescriptorSet`] handle\n\n* []() VUID-vkUpdateDescriptorSetWithTemplate-descriptorUpdateTemplate-parameter  \n  `descriptorUpdateTemplate` **must** be a valid [`crate::vk::DescriptorUpdateTemplate`] handle\n\n* []() VUID-vkUpdateDescriptorSetWithTemplate-descriptorUpdateTemplate-parent  \n  `descriptorUpdateTemplate` **must** have been created, allocated, or retrieved from `device`\n\nHost Synchronization\n\n* Host access to `descriptorSet` **must** be externally synchronized\n\nAPI example\n\n```\nstruct AppBufferView {\n    VkBufferView bufferView;\n    uint32_t     applicationRelatedInformation;\n};\n\nstruct AppDataStructure\n{\n    VkDescriptorImageInfo  imageInfo;          // a single image info\n    VkDescriptorBufferInfo bufferInfoArray[3]; // 3 buffer infos in an array\n    AppBufferView          bufferView[2];      // An application defined structure containing a bufferView\n    // ... some more application related data\n};\n\nconst VkDescriptorUpdateTemplateEntry descriptorUpdateTemplateEntries[] =\n{\n    // binding to a single image descriptor\n    {\n        0,                                           // binding\n        0,                                           // dstArrayElement\n        1,                                           // descriptorCount\n        VK_DESCRIPTOR_TYPE_COMBINED_IMAGE_SAMPLER,   // descriptorType\n        offsetof(AppDataStructure, imageInfo),       // offset\n        0                                            // stride is not required if descriptorCount is 1\n    },\n\n    // binding to an array of buffer descriptors\n    {\n        1,                                           // binding\n        0,                                           // dstArrayElement\n        3,                                           // descriptorCount\n        VK_DESCRIPTOR_TYPE_UNIFORM_BUFFER,           // descriptorType\n        offsetof(AppDataStructure, bufferInfoArray), // offset\n        sizeof(VkDescriptorBufferInfo)               // stride, descriptor buffer infos are compact\n    },\n\n    // binding to an array of buffer views\n    {\n        2,                                           // binding\n        0,                                           // dstArrayElement\n        2,                                           // descriptorCount\n        VK_DESCRIPTOR_TYPE_STORAGE_TEXEL_BUFFER,     // descriptorType\n        offsetof(AppDataStructure, bufferView) +\n          offsetof(AppBufferView, bufferView),       // offset\n        sizeof(AppBufferView)                        // stride, bufferViews do not have to be compact\n    },\n};\n\n// create a descriptor update template for descriptor set updates\nconst VkDescriptorUpdateTemplateCreateInfo createInfo =\n{\n    VK_STRUCTURE_TYPE_DESCRIPTOR_UPDATE_TEMPLATE_CREATE_INFO,  // sType\n    NULL,                                                      // pNext\n    0,                                                         // flags\n    3,                                                         // descriptorUpdateEntryCount\n    descriptorUpdateTemplateEntries,                           // pDescriptorUpdateEntries\n    VK_DESCRIPTOR_UPDATE_TEMPLATE_TYPE_DESCRIPTOR_SET,         // templateType\n    myLayout,                                                  // descriptorSetLayout\n    0,                                                         // pipelineBindPoint, ignored by given templateType\n    0,                                                         // pipelineLayout, ignored by given templateType\n    0,                                                         // set, ignored by given templateType\n};\n\nVkDescriptorUpdateTemplate myDescriptorUpdateTemplate;\nmyResult = vkCreateDescriptorUpdateTemplate(\n    myDevice,\n    &createInfo,\n    NULL,\n    &myDescriptorUpdateTemplate);\n\nAppDataStructure appData;\n\n// fill appData here or cache it in your engine\nvkUpdateDescriptorSetWithTemplate(myDevice, myDescriptorSet, myDescriptorUpdateTemplate, &appData);\n```\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DescriptorSet`], [`crate::vk::DescriptorUpdateTemplate`], [`crate::vk::Device`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkUpdateDescriptorSetWithTemplateKHR = crate::vk1_1::PFN_vkUpdateDescriptorSetWithTemplate;
#[doc = "Provided by [`crate::extensions::khr_descriptor_update_template`]"]
impl crate::vk1_0::StructureType {
    pub const DESCRIPTOR_UPDATE_TEMPLATE_CREATE_INFO_KHR: Self = Self::DESCRIPTOR_UPDATE_TEMPLATE_CREATE_INFO;
}
#[doc = "Provided by [`crate::extensions::khr_descriptor_update_template`]"]
impl crate::vk1_0::ObjectType {
    pub const DESCRIPTOR_UPDATE_TEMPLATE_KHR: Self = Self::DESCRIPTOR_UPDATE_TEMPLATE;
}
#[doc = "Provided by [`crate::extensions::khr_descriptor_update_template`]"]
impl crate::vk1_1::DescriptorUpdateTemplateType {
    pub const DESCRIPTOR_SET_KHR: Self = Self::DESCRIPTOR_SET;
}
#[doc = "Provided by [`crate::extensions::khr_descriptor_update_template`]"]
impl crate::extensions::ext_debug_report::DebugReportObjectTypeEXT {
    pub const DESCRIPTOR_UPDATE_TEMPLATE_KHR_EXT: Self = Self::DESCRIPTOR_UPDATE_TEMPLATE_EXT;
}
#[doc = "Provided by [`crate::extensions::khr_descriptor_update_template`]"]
impl crate::DeviceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCreateDescriptorUpdateTemplateKHR.html)) · Function <br/> vkCreateDescriptorUpdateTemplate - Create a new descriptor update template\n[](#_c_specification)C Specification\n----------\n\nUpdating a large [`crate::vk::DescriptorSet`] array **can** be an expensive operation\nsince an application **must** specify one [`crate::vk::WriteDescriptorSet`] structure\nfor each descriptor or descriptor array to update, each of which\nre-specifies the same state when updating the same descriptor in multiple\ndescriptor sets.\nFor cases when an application wishes to update the same set of descriptors\nin multiple descriptor sets allocated using the same[`crate::vk::DescriptorSetLayout`], [`crate::vk::PFN_vkUpdateDescriptorSetWithTemplate`] **can** be\nused as a replacement for [`crate::vk::PFN_vkUpdateDescriptorSets`].\n\n[`crate::vk::DescriptorUpdateTemplate`] allows implementations to convert a set of\ndescriptor update operations on a single descriptor set to an internal\nformat that, in conjunction with [`crate::vk::PFN_vkUpdateDescriptorSetWithTemplate`]or [`crate::vk::DeviceLoader::cmd_push_descriptor_set_with_template_khr`], **can** be more efficient compared to calling [`crate::vk::PFN_vkUpdateDescriptorSets`]or [`crate::vk::DeviceLoader::cmd_push_descriptor_set_khr`].\nThe descriptors themselves are not specified in the[`crate::vk::DescriptorUpdateTemplate`], rather, offsets into an application\nprovided pointer to host memory are specified, which are combined with a\npointer passed to [`crate::vk::PFN_vkUpdateDescriptorSetWithTemplate`]or [`crate::vk::DeviceLoader::cmd_push_descriptor_set_with_template_khr`].\nThis allows large batches of updates to be executed without having to\nconvert application data structures into a strictly-defined Vulkan data\nstructure.\n\nTo create a descriptor update template, call:\n\n```\n// Provided by VK_VERSION_1_1\nVkResult vkCreateDescriptorUpdateTemplate(\n    VkDevice                                    device,\n    const VkDescriptorUpdateTemplateCreateInfo* pCreateInfo,\n    const VkAllocationCallbacks*                pAllocator,\n    VkDescriptorUpdateTemplate*                 pDescriptorUpdateTemplate);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_descriptor_update_template\nVkResult vkCreateDescriptorUpdateTemplateKHR(\n    VkDevice                                    device,\n    const VkDescriptorUpdateTemplateCreateInfo* pCreateInfo,\n    const VkAllocationCallbacks*                pAllocator,\n    VkDescriptorUpdateTemplate*                 pDescriptorUpdateTemplate);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that creates the descriptor update\n  template.\n\n* `pCreateInfo` is a pointer to a[`crate::vk::DescriptorUpdateTemplateCreateInfo`] structure specifying the set\n  of descriptors to update with a single call to[`crate::vk::DeviceLoader::cmd_push_descriptor_set_with_template_khr`] or[`crate::vk::PFN_vkUpdateDescriptorSetWithTemplate`].\n\n* `pAllocator` controls host memory allocation as described in the[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation) chapter.\n\n* `pDescriptorUpdateTemplate` is a pointer to a[`crate::vk::DescriptorUpdateTemplate`] handle in which the resulting\n  descriptor update template object is returned.\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-vkCreateDescriptorUpdateTemplate-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkCreateDescriptorUpdateTemplate-pCreateInfo-parameter  \n  `pCreateInfo` **must** be a valid pointer to a valid [`crate::vk::DescriptorUpdateTemplateCreateInfo`] structure\n\n* []() VUID-vkCreateDescriptorUpdateTemplate-pAllocator-parameter  \n   If `pAllocator` is not `NULL`, `pAllocator` **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkCreateDescriptorUpdateTemplate-pDescriptorUpdateTemplate-parameter  \n  `pDescriptorUpdateTemplate` **must** be a valid pointer to a [`crate::vk::DescriptorUpdateTemplate`] handle\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::DescriptorUpdateTemplate`], [`crate::vk::DescriptorUpdateTemplateCreateInfo`], [`crate::vk::Device`]\n"]
    #[doc(alias = "vkCreateDescriptorUpdateTemplateKHR")]
    pub unsafe fn create_descriptor_update_template_khr(&self, create_info: &crate::vk1_1::DescriptorUpdateTemplateCreateInfo, allocator: Option<&crate::vk1_0::AllocationCallbacks>) -> crate::utils::VulkanResult<crate::vk1_1::DescriptorUpdateTemplate> {
        let _function = self.create_descriptor_update_template_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut descriptor_update_template = Default::default();
        let _return = _function(
            self.handle,
            create_info as _,
            match allocator {
                Some(v) => v,
                None => std::ptr::null(),
            },
            &mut descriptor_update_template,
        );
        crate::utils::VulkanResult::new(_return, descriptor_update_template)
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkDestroyDescriptorUpdateTemplateKHR.html)) · Function <br/> vkDestroyDescriptorUpdateTemplate - Destroy a descriptor update template object\n[](#_c_specification)C Specification\n----------\n\nTo destroy a descriptor update template, call:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkDestroyDescriptorUpdateTemplate(\n    VkDevice                                    device,\n    VkDescriptorUpdateTemplate                  descriptorUpdateTemplate,\n    const VkAllocationCallbacks*                pAllocator);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_descriptor_update_template\nvoid vkDestroyDescriptorUpdateTemplateKHR(\n    VkDevice                                    device,\n    VkDescriptorUpdateTemplate                  descriptorUpdateTemplate,\n    const VkAllocationCallbacks*                pAllocator);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that has been used to create the\n  descriptor update template\n\n* `descriptorUpdateTemplate` is the descriptor update template to\n  destroy.\n\n* `pAllocator` controls host memory allocation as described in the[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation) chapter.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-vkDestroyDescriptorUpdateTemplate-descriptorSetLayout-00356  \n   If [`crate::vk::AllocationCallbacks`] were provided when`descriptorUpdateTemplate` was created, a compatible set of\n  callbacks **must** be provided here\n\n* []() VUID-vkDestroyDescriptorUpdateTemplate-descriptorSetLayout-00357  \n   If no [`crate::vk::AllocationCallbacks`] were provided when`descriptorUpdateTemplate` was created, `pAllocator` **must** be`NULL`\n\nValid Usage (Implicit)\n\n* []() VUID-vkDestroyDescriptorUpdateTemplate-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkDestroyDescriptorUpdateTemplate-descriptorUpdateTemplate-parameter  \n   If `descriptorUpdateTemplate` is not [VK\\_NULL\\_HANDLE](VK_NULL_HANDLE.html), `descriptorUpdateTemplate` **must** be a valid [`crate::vk::DescriptorUpdateTemplate`] handle\n\n* []() VUID-vkDestroyDescriptorUpdateTemplate-pAllocator-parameter  \n   If `pAllocator` is not `NULL`, `pAllocator` **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkDestroyDescriptorUpdateTemplate-descriptorUpdateTemplate-parent  \n   If `descriptorUpdateTemplate` is a valid handle, it **must** have been created, allocated, or retrieved from `device`\n\nHost Synchronization\n\n* Host access to `descriptorUpdateTemplate` **must** be externally synchronized\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::DescriptorUpdateTemplate`], [`crate::vk::Device`]\n"]
    #[doc(alias = "vkDestroyDescriptorUpdateTemplateKHR")]
    pub unsafe fn destroy_descriptor_update_template_khr(&self, descriptor_update_template: Option<crate::vk1_1::DescriptorUpdateTemplate>, allocator: Option<&crate::vk1_0::AllocationCallbacks>) -> () {
        let _function = self.destroy_descriptor_update_template_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(
            self.handle,
            match descriptor_update_template {
                Some(v) => v,
                None => Default::default(),
            },
            match allocator {
                Some(v) => v,
                None => std::ptr::null(),
            },
        );
        ()
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkUpdateDescriptorSetWithTemplateKHR.html)) · Function <br/> vkUpdateDescriptorSetWithTemplate - Update the contents of a descriptor set object using an update template\n[](#_c_specification)C Specification\n----------\n\nOnce a [`crate::vk::DescriptorUpdateTemplate`] has been created, descriptor sets**can** be updated by calling:\n\n```\n// Provided by VK_VERSION_1_1\nvoid vkUpdateDescriptorSetWithTemplate(\n    VkDevice                                    device,\n    VkDescriptorSet                             descriptorSet,\n    VkDescriptorUpdateTemplate                  descriptorUpdateTemplate,\n    const void*                                 pData);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_KHR_descriptor_update_template\nvoid vkUpdateDescriptorSetWithTemplateKHR(\n    VkDevice                                    device,\n    VkDescriptorSet                             descriptorSet,\n    VkDescriptorUpdateTemplate                  descriptorUpdateTemplate,\n    const void*                                 pData);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that updates the descriptor set.\n\n* `descriptorSet` is the descriptor set to update\n\n* `descriptorUpdateTemplate` is a [`crate::vk::DescriptorUpdateTemplate`]object specifying the update mapping between `pData` and the\n  descriptor set to update.\n\n* `pData` is a pointer to memory containing one or more [`crate::vk::DescriptorImageInfo`], [`crate::vk::DescriptorBufferInfo`], or [`crate::vk::BufferView`] structures\n  or [`crate::vk::AccelerationStructureKHR`]or [`crate::vk::AccelerationStructureNV`]handles used to write the descriptors.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-vkUpdateDescriptorSetWithTemplate-pData-01685  \n  `pData` **must** be a valid pointer to a memory containing one or more\n  valid instances of [`crate::vk::DescriptorImageInfo`],[`crate::vk::DescriptorBufferInfo`], or [`crate::vk::BufferView`] in a layout defined\n  by `descriptorUpdateTemplate` when it was created with[`crate::vk::PFN_vkCreateDescriptorUpdateTemplate`]\n\nValid Usage (Implicit)\n\n* []() VUID-vkUpdateDescriptorSetWithTemplate-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkUpdateDescriptorSetWithTemplate-descriptorSet-parameter  \n  `descriptorSet` **must** be a valid [`crate::vk::DescriptorSet`] handle\n\n* []() VUID-vkUpdateDescriptorSetWithTemplate-descriptorUpdateTemplate-parameter  \n  `descriptorUpdateTemplate` **must** be a valid [`crate::vk::DescriptorUpdateTemplate`] handle\n\n* []() VUID-vkUpdateDescriptorSetWithTemplate-descriptorUpdateTemplate-parent  \n  `descriptorUpdateTemplate` **must** have been created, allocated, or retrieved from `device`\n\nHost Synchronization\n\n* Host access to `descriptorSet` **must** be externally synchronized\n\nAPI example\n\n```\nstruct AppBufferView {\n    VkBufferView bufferView;\n    uint32_t     applicationRelatedInformation;\n};\n\nstruct AppDataStructure\n{\n    VkDescriptorImageInfo  imageInfo;          // a single image info\n    VkDescriptorBufferInfo bufferInfoArray[3]; // 3 buffer infos in an array\n    AppBufferView          bufferView[2];      // An application defined structure containing a bufferView\n    // ... some more application related data\n};\n\nconst VkDescriptorUpdateTemplateEntry descriptorUpdateTemplateEntries[] =\n{\n    // binding to a single image descriptor\n    {\n        0,                                           // binding\n        0,                                           // dstArrayElement\n        1,                                           // descriptorCount\n        VK_DESCRIPTOR_TYPE_COMBINED_IMAGE_SAMPLER,   // descriptorType\n        offsetof(AppDataStructure, imageInfo),       // offset\n        0                                            // stride is not required if descriptorCount is 1\n    },\n\n    // binding to an array of buffer descriptors\n    {\n        1,                                           // binding\n        0,                                           // dstArrayElement\n        3,                                           // descriptorCount\n        VK_DESCRIPTOR_TYPE_UNIFORM_BUFFER,           // descriptorType\n        offsetof(AppDataStructure, bufferInfoArray), // offset\n        sizeof(VkDescriptorBufferInfo)               // stride, descriptor buffer infos are compact\n    },\n\n    // binding to an array of buffer views\n    {\n        2,                                           // binding\n        0,                                           // dstArrayElement\n        2,                                           // descriptorCount\n        VK_DESCRIPTOR_TYPE_STORAGE_TEXEL_BUFFER,     // descriptorType\n        offsetof(AppDataStructure, bufferView) +\n          offsetof(AppBufferView, bufferView),       // offset\n        sizeof(AppBufferView)                        // stride, bufferViews do not have to be compact\n    },\n};\n\n// create a descriptor update template for descriptor set updates\nconst VkDescriptorUpdateTemplateCreateInfo createInfo =\n{\n    VK_STRUCTURE_TYPE_DESCRIPTOR_UPDATE_TEMPLATE_CREATE_INFO,  // sType\n    NULL,                                                      // pNext\n    0,                                                         // flags\n    3,                                                         // descriptorUpdateEntryCount\n    descriptorUpdateTemplateEntries,                           // pDescriptorUpdateEntries\n    VK_DESCRIPTOR_UPDATE_TEMPLATE_TYPE_DESCRIPTOR_SET,         // templateType\n    myLayout,                                                  // descriptorSetLayout\n    0,                                                         // pipelineBindPoint, ignored by given templateType\n    0,                                                         // pipelineLayout, ignored by given templateType\n    0,                                                         // set, ignored by given templateType\n};\n\nVkDescriptorUpdateTemplate myDescriptorUpdateTemplate;\nmyResult = vkCreateDescriptorUpdateTemplate(\n    myDevice,\n    &createInfo,\n    NULL,\n    &myDescriptorUpdateTemplate);\n\nAppDataStructure appData;\n\n// fill appData here or cache it in your engine\nvkUpdateDescriptorSetWithTemplate(myDevice, myDescriptorSet, myDescriptorUpdateTemplate, &appData);\n```\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DescriptorSet`], [`crate::vk::DescriptorUpdateTemplate`], [`crate::vk::Device`]\n"]
    #[doc(alias = "vkUpdateDescriptorSetWithTemplateKHR")]
    pub unsafe fn update_descriptor_set_with_template_khr(&self, descriptor_set: crate::vk1_0::DescriptorSet, descriptor_update_template: crate::vk1_1::DescriptorUpdateTemplate, data: *const std::ffi::c_void) -> () {
        let _function = self.update_descriptor_set_with_template_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(self.handle, descriptor_set as _, descriptor_update_template as _, data);
        ()
    }
}
